



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Promise的简单用法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Promise的简单用法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 02:01:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>众所周知的，Javascript是一种单线程的语言，所有的代码必须按照所谓的&ldquo;自上而下&rdquo;的顺序来执行。本特性带来的问题就是，一些将来的、未知的操作，必须异步实现。本文将讨论一个比较常见的异步解决方案&mdash;&mdash;Promise，时至本文最后更新的日子，Promise的应用已经极其广泛。</p>
<p><strong>Promise解决的问题</strong></p>
<p>我相信每个前端都遇到过这样一个问题，当一个异步任务的执行需要依赖另一个异步任务的结果时，我们一般会将两个异步任务嵌套起来，这种情况发生一两次还可以忍，但是发生很多次之后，你的代码就会变成这个熊样：</p>
<div>
<pre class="prettyprint linenums"><code>async1(function(){<br />
    async2(function(){<br />
        async3(function(<br />
            async4(funciton(){<br />
                async5(function(){<br />
                    //(╯&deg;&deg;）╯︵┻━┻<br />
                    //...<br />
                });<br />
            });<br />
        ));<br />
    });<br />
});</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>这就是所谓的回调地狱，代码层层嵌套，环环相扣，很明显，逻辑稍微复杂一些，这样的程序就会变得难以维护。</p>
<p>对于这种情况，程序员们想了很多解决方案（比如将代码模块化），但流程控制上，还是没有跳出})的大量嵌套。但去年ES2015的标准里，Promise的标准化，一定程度上解决了JavaScript的流程操作问题。</p>
<p><strong>Promise的基本用法</strong></p>
<p>时至今日，很多现代浏览器都已经实现，但是为了兼容，建议自行对Promise进行封装或者使用第三方的解决方案（如webpack对es6语法进行编译）。 那么，我么将得到一个Promise构造函数，新建一个Promise的实例：</p>
<div>
<pre class="prettyprint linenums"><code>var _promise = new Promise(function(resolve, reject){<br />
        setTimeout(function(){<br />
            var rand = Math.random();<br />
            if(rand&lt;0.5){<br />
                resolve("resolve" + rand);<br />
            }else{<br />
                reject("reject" + rand);<br />
            }<br />
        },1000);

    });

    /*运行结果:<br />
     *有两种情况：<br />
     *1)无事发生<br />
     *2)报错形如：d.js:7 Uncaught (in promise) reject0.9541820247347901<br />
     */</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>由上所示，Promise的构造函数接收一个函数作为参数，该函数接受两个额外的函数，resolve和reject，这两个函数分别代表将当前Promise置为fulfilled(解决)和rejected(拒绝)两个状态。Promise正是通过这两个状态来控制异步操作的结果。接下来我们将讨论Promise的用法，实际上Promise上的实例_promise是一个对象，不是一个函数。在声明的时候，Promise传递的参数函数会立即执行，因此Promise使用的正确姿势是在其外层再包裹一层函数。</p>
<div>
<pre class="prettyprint linenums"><code>var run = function(){<br />
        var _promise = new Promise(function(resolve, reject){<br />
            setTimeout(function(){<br />
                var rand = Math.random();<br />
                if(rand&lt;0.5){<br />
                    resolve("resolve" + rand);<br />
                }else{<br />
                    reject("reject" + rand);<br />
                }<br />
            },1000);<br />
        });<br />
        return _promise;<br />
    }<br />
    run();</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>这是Promise的正常用法，接下来，就是对异步操作结果的处理，接着上面创建的函数run()</p>
<div>
<pre class="prettyprint linenums"><code>run().then(function(data){<br />
        console.log(data);<br />
    });</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>每个Promise的实例对象，都有一个then的方法，这个方法就是用来处理之前各种异步逻辑的结果。</p>
<p>那么, 各位可能会问， 这么做有什么用？</p>
<p>当然有用，到目前为止，我们学会了Promise的基本流程，但是这种用法和嵌套回调函数似乎没什么区别，而且增加了复杂度。但是我们说了，Promise的用处，实际上是在于多重异步操作相互依赖的情况下，对于逻辑流程的控制。Promise正是通过对两种状态的控制，以此来解决流程的控制。请看如下代码：</p>
<div>
<pre class="prettyprint linenums"><code>run().then(function(data){<br />
    //处理resolve的代码<br />
    cosnole.log("Promise被置为resolve",data);<br />
},function(data){<br />
    //处理reject的代码<br />
    cosnole.log("程序被置为了reject",data);<br />
})</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>如果异步操作获得了我们想要的结果，那我们将调用resolve函数，在then的第一个作为参数的匿名函数中可以获取数据，如果我们得到了错误的结果，调用reject函数，在then函数的第二个作为参数的匿名函数中获取错误处理数据。 这样，一个次完整的Promise调用就结束了。对于Promise的then()方法，then总是会返回一个Promise实例，因此你可以一直调用then，形如run().then().then().then().then().then()..... 在一个then()方法调用异步处理成功的状态时，你既可以return一个确定的&ldquo;值&rdquo;，也可以再次返回一个Promise实例，当返回的是一个确切的值的时候，then会将这个确切的值传入一个默认的Promise实例，并且这个Promise实例会立即置为fulfilled状态，以供接下来的then方法里使用。如下所示：</p>
<div>
<pre class="prettyprint linenums"><code>run().then(function(data){<br />
        console.log("第一次",data);<br />
        return data;<br />
    }).then(function(data){<br />
        console.log("第二次",data);<br />
        return data;<br />
    }).then(function(data){<br />
        console.log("第三次",data);<br />
        return data;<br />
    });<br />
    /* 异步处理成功的打印结果：<br />
        第一次 resolve0.49040459200760167d.js:18<br />
        第二次 resolve0.49040459200760167d.js:21<br />
        第三次 resolve0.49040459200760167<br />
        由此可知then方法可以无限调用下去。<br />
    */</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>根据这个特性，我们就可以将相互依赖的多个异步逻辑，进行比较顺序的管理了。下面举一个拥有3个异步操作的例子，代码有些长。</p>
<div>
<pre class="prettyprint linenums"><code>//第一个异步任务<br />
    function run_a(){<br />
        return new Promise(function(resolve, reject){<br />
            //假设已经进行了异步操作，并且获得了数据<br />
            resolve("step1");<br />
        });<br />
    }<br />
    //第二个异步任务<br />
    function run_b(data_a){<br />
        return new Promise(function(resolve, reject){<br />
            //假设已经进行了异步操作，并且获得了数据<br />
            console.log(data_a);<br />
            resolve("step2");<br />
        });<br />
    }<br />
    //第三个异步任务<br />
    function run_c(data_b){<br />
        return new Promise(function(resolve, reject){<br />
            //假设已经进行了异步操作，并且获得了数据<br />
            console.log(data_b);<br />
            resolve("step3");<br />
        });<br />
    }

    //连续调用<br />
    run_a().then(function(data){<br />
        return run_b(data);<br />
    }).then(function(data){<br />
        return run_c(data);<br />
    }).then(function(data){<br />
        console.log(data);<br />
    });

    /*运行结果<br />
      step1<br />
      step2<br />
      step3<br />
    */</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>根据这个特性，我们就可以将相互依赖的多个异步逻辑，进行比较顺序的管理了。下面举一个拥有3个异步操作的例子，代码有些长。</p>
<div>
<pre class="prettyprint linenums"><code>//第一个异步任务<br />
    function run_a(){<br />
        return new Promise(function(resolve, reject){<br />
            //假设已经进行了异步操作，并且获得了数据<br />
            resolve("step1");<br />
        });<br />
    }<br />
    //第二个异步任务<br />
    function run_b(data_a){<br />
        return new Promise(function(resolve, reject){<br />
            //假设已经进行了异步操作，并且获得了数据<br />
            console.log(data_a);<br />
            resolve("step2");<br />
        });<br />
    }<br />
    //第三个异步任务<br />
    function run_c(data_b){<br />
        return new Promise(function(resolve, reject){<br />
            //假设已经进行了异步操作，并且获得了数据<br />
            console.log(data_b);<br />
            resolve("step3");<br />
        });<br />
    }

    //连续调用<br />
    run_a().then(function(data){<br />
        return run_b(data);<br />
    }).then(function(data){<br />
        return run_c(data);<br />
    }).then(function(data){<br />
        console.log(data);<br />
    });

    /*运行结果<br />
      step1<br />
      step2<br />
      step3<br />
    */</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>这样，连续依赖的几个异步操作，就完成了，解决了让人头痛的回调地狱问题。</p>
<p><strong>异步操作拒绝及中断调用链</strong></p>
<p>前文提到过，then方法可以接收两个匿名函数作为参数，第一个参数是Promise置为fulfilled状态后的回调，第二个是置为rejected状态的回调。在很多情况下，如果连续的几个异步任务，其中某个异步任务处理失败，那么接下来的几个任务很大程度上就不需要继续处理了，那么我们该如何终止then的调用链呢？在Promsie的实例上，除了then方法外，还有一个catch方法，catch方法的具体作用，我们沿用上面的代码，将run_a()改造一下来看：</p>
<div>
<pre class="prettyprint linenums"><code>//修改run_a的一步操作可能存在拒绝状态<br />
    function run_a(){<br />
        return new Promise(function(resolve, reject){<br />
            setTimeout(function(){<br />
                if(Math.random()&gt;.5){<br />
                    resolve("step1");<br />
                }else{<br />
                    reject("error");<br />
                }<br />
            },1000);<br />
        });<br />
    }

    //这样做不会中断<br />
    run_a().then(function(data){<br />
        return run_b(data);<br />
    },function(data){<br />
        //如果是这样处理rejected状态，并不会中断调用链<br />
        return data;<br />
    }).then(function(data){<br />
        return run_c(data);<br />
    }).then(function(data){<br />
        console.log(data);<br />
    });

    //在调用链的末尾加上catch方法，当某个环节的Promise的异步处理出错时，将中断其后的调用，直接跳到最后的catch<br />
    run_a().then(function(data){<br />
        return run_b(data);<br />
    }).then(function(data){<br />
        return run_c(data);<br />
    }).then(function(data){<br />
        console.log(data);<br />
    }).catch(function(e){<br />
        //rejected的状态将直接跳到catch里，剩下的调用不会再继续<br />
        console.log(e);<br />
    });</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p><strong>ES6对Promise/A+的扩展</strong></p>
<p>Promise的提出的时间很早，其标准称为Promise/A+，内容不多，ES6将Promise写入了标准，并在其基础上进行了扩展，具体可以参考：</p>
<p>&middot; 由malcolm yud对Promise/A+的翻译 &middot; 阮一峰ES6入门&mdash;Promise</p>
<p>这里将讲一下ES6对Promise标准的扩展，也可以直接看上面的参考链接</p>
<p><strong>Promise.all的扩展</strong></p>
<p>本扩展实现了将多个异步操作合并为一个操作，也就是并行处理异步，最后统一操作结果，注意:本方法只能通过Promise对象直接调用，实例不能进行此操作。</p>
<p>all()接收一个参数数组，数组中的每一项都对应一个</p>
<div>
<pre class="prettyprint linenums"><code>//第一个异步任务<br />
function run_a(){<br />
    return new Promise(function(resolve, reject){<br />
        //假设已经进行了异步操作，并且获得了数据<br />
        resolve("step1")<br />
    });<br />
}<br />
//第二个异步任务<br />
function run_b(){<br />
    return new Promise(function(resolve, reject){<br />
        //假设已经进行了异步操作，并且获得了数据<br />
        resolve("step2");<br />
    });<br />
}<br />
//第三个异步任务<br />
function run_c(){<br />
    return new Promise(function(resolve, reject){<br />
        //假设已经进行了异步操作，并且获得了数据<br />
        resolve("step3");<br />
    });<br />
}

Promise.all([run_a(),run_b(),run_c()]).then(function(data){<br />
    console.log(data);<br />
},function(data){<br />
    console.log(data);<br />
});<br />
/*打印结果<br />
  ["step1","step2","step3"]<br />
*/

//修改第二个异步任务<br />
//第一个异步任务<br />
function run_b(){<br />
    return new Promise(function(resolve, reject){<br />
        //假设已经进行了异步操作，并且获得了数据<br />
        reject("step2")<br />
    });<br />
}<br />
/*打印结果<br />
 *捕获了第一个出现的拒绝状态的数据<br />
  ["step2"]<br />
*/</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>由上所示，并行运算的结果将按照入参顺序放在放在数组里返回。</p>
<p><strong>Promise.race的扩展</strong></p>
<p>race本意为赛跑，顾名思义，race的用法就是并列的几个异步操作，谁先处理结束就以谁为准。</p>
<div>
<pre class="prettyprint linenums"><code>//第一个异步任务<br />
    function run_a(){<br />
        return new Promise(function(resolve, reject){<br />
            setTimeout(function(){<br />
                console.log("执行到step1");<br />
                resolve("step1")<br />
            },3000);<br />
        });<br />
    }<br />
    //第二个异步任务<br />
    function run_b(){<br />
        return new Promise(function(resolve, reject){<br />
            setTimeout(function(){<br />
                console.log("执行到step2");<br />
                resolve("step2");<br />
            },1000);<br />
        });<br />
    }<br />
    //第三个异步任务<br />
    function run_c(){<br />
        return new Promise(function(resolve, reject){<br />
            setTimeout(function(){<br />
                console.log("执行到step3");<br />
                resolve("step3");<br />
            },3000);<br />
        });<br />
    }

    Promise.race([run_a(),run_b(),run_c()]).then(function(results){<br />
        console.log(results);<br />
    },function(data){<br />
        console.log(data);<br />
    });<br />
    /*<br />
        打印结果:<br />
        执行到step2<br />
        step2<br />
        执行到step1<br />
        执行到step3<br />
    */</code></pre>
<p><img referrerpolicy="no-referrer"src="data:image/gif;base64,R0lGODlhAQABAPABAP///wAAACH5BAEKAAAALAAAAAABAAEAAAICRAEAOw==" /></div>
<p>可以看出，run_b先执行完，进入了then函数进行回调，但需要注意的是，第一个结束的异步操作回调后，其它的异步操作还会继续执行，只是并不会继续进入then了而已。</p>
<p><strong>结语</strong></p>
<p>以上就是对ES6标准下的Promise的简单理解，Promise出现的时间不短，在很多开源项目里被广泛应用，理解了Promise，有助于对代码的进一步理解。本篇文章作为我个人的学习记录，希望起到抛砖引玉的作用，对大家的学习起到点点作用。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gj0097.html">多线程爬坑之路-Thread和Runable源码解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/495v260q.html">eclipse远程调试Tomcat方法&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93rk3z9.html">poj1251 最小生成树</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zz0w18.html">RDBMS，memcache</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv4gz1q.html">【ASP&period;NET 插件】zyUpload的HTML5上传插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok5ov59.html">二维码扫描 zxing源码分析（三）result、history部分</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oyn2v9.html">NSDate &amp;amp&semi; NSDateFormatter</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn4xk2q.html">perf---LINUX内核研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj44jlq.html">JS的console使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdl219.html">React Native之APK文件签名及打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdplx1zq.html">MYSQL问题解决方案：Access denied for user &amp;&num;39&semi;root&amp;&num;39&semi;&commat;&amp;&num;39&semi;localhost&amp;&num;39&semi; &lpar;using password&colon;YES&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4l5w8.html">lpad函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m6vx38.html">java实现二叉树的建立以及实现二叉查找树的查、插、删、遍历</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj1wr38.html">浅析MySQL 8忘记密码处理方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r7zd68.html">5、web站点架构模式简介及Nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ok2we8.html">vue 路由 以及默认路由跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zym7wv9.html">简单创建一个&OpenCurlyDoubleQuote;嗨新房&rdquo;的mac客户端</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w0dzrq.html">GitHub多人协作简明教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4dr1xq.html">8&period;20 前端 js</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pvxr08.html">PHP 序列化变量的 4 种方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93w14ywq.html">RN animated缩放动画</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll0rv1q.html">20180322 对DataTable里面的数据进行去重</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdg3x09.html">RestFramework自定制之认证和权限、限制访问频率</a>
			</li>
						<li><a href="https://www.batexi.com/a/q251zzvq.html">Lint&mdash;&mdash;Android SDK提供的静态代码扫描工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnveo7g8.html">js或jsp 获取项目路径常用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rx3g48.html">vue-电脑端导出-txt</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5lvz4q.html">equals和contains的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnve7dx8.html">&lbrack;django&rsqb;cbv方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g14jzq.html">Gradle全局变量定义及引用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5le2eq.html">三维bfs&lpar;HUD1253胜利大逃亡）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
